;;; hypersrc-faces.el -- Faces to use for headers in HyperSource mode

;;; $Id: hypersrc-faces.el,v 0.3 1995/05/17 09:17:51 job Exp $

(make-face 'hypersrc-header1-face)
(make-face 'hypersrc-header2-face)
(make-face 'hypersrc-header3-face)
(make-face 'hypersrc-header4-face)
(make-face 'hypersrc-header5-face)
(make-face 'hypersrc-header6-face)
(set-face-font 
 'hypersrc-header1-face "-*-times-medium-r-*-*-*-240-*-*-*-*-iso8859-1")
(set-face-font
 'hypersrc-header2-face "-*-times-medium-r-*-*-*-180-*-*-*-*-iso8859-1")
(set-face-font
 'hypersrc-header3-face "-*-times-medium-r-*-*-*-140-*-*-*-*-iso8859-1")
(set-face-font
 'hypersrc-header4-face "-*-times-medium-r-*-*-*-120-*-*-*-*-iso8859-1")
(set-face-font
 'hypersrc-header5-face "-*-times-medium-r-*-*-*-110-*-*-*-*-iso8859-1")
(set-face-font
 'hypersrc-header6-face "-*-times-medium-r-*-*-*-100-*-*-*-*-iso8859-1")

;;; Face to use for marginal comments in HyperSource mode:
(make-face 'hypersrc-comment-face)
(set-face-font 
 'hypersrc-comment-face "-*-times-medium-r-*-*-*-100-*-*-*-*-iso8859-1")

;;; Face to use for hyperlinks in HyperSource mode:
(make-face 'hypersrc-link-face)
(set-face-underline-p 'hypersrc-link-face t)
(set-face-foreground 'hypersrc-link-face "blue3")

;;; Face to use for hyperlink targets in HyperSource mode:
(make-face 'hypersrc-target-face)
(set-face-font 'hypersrc-target-face "-*-fixed-bold-r-*-*-*-130-*-*-*-*-iso8859-1")


(provide 'hypersrc-faces)
