#!/bin/csh -f

# pnmscale.sh - Wrapper around pnmscale

# $Id: pnmscale.sh,v 1.1 1995/05/23 13:19:11 job Exp $

# Function: Scale image only if it is *larger* than $HYPERSRC_MARGIN
# -f for csh ignores .cshrc

cat $1 > ${1:r}.unscaled.ppm
if (`pnmfile ${1:r}.unscaled.ppm | awk '{print $4}'` > $HYPERSRC_MARGIN) then
  pnmscale -xsize $HYPERSRC_MARGIN ${1:r}.unscaled.ppm | pnmdepth 1
else
  cat ${1:r}.unscaled.ppm
endif
/bin/rm ${1:r}.unscaled.ppm
