;;; hypersrc-comments.el --- finding comment delimiters for a given major mode.

;;; $Id: hypersrc-comments.el,v 1.2 1995/05/17 09:17:51 job Exp $

(defun hypersrc-open-comment (mode)
  "Return character sequence to open a comment in MODE."
  (elt (assq mode hypersrc-mode-comment-alist) 1))

(defun hypersrc-close-comment (mode)
  "Return character sequence to close a comment in MODE."
  (elt (assq mode hypersrc-mode-comment-alist) 2))

(provide 'hypersrc-comments)
