#!/bin/csh -f

# pstoppm.sh - Wrapper for pstopnm to pipe result to stdout.
# Part of the HyperSource package for XEmacs
# -f for csh ignores .cshrc

# Run pstopnm from the netpbm package with file name argument:
pstopnm -xmax $HYPERSRC_MARGIN -portrait $1 >&/dev/null

# An alternative way would be something like:
# gs -q -sDEVICE=ppm -sOutputFile=${1:r}.ppm -r72 - $1

# Pipe the resulting PPM file (of the first page) to stdout:
cat ${1:r}001.ppm

# Erase temp file:
/bin/rm ${1:r}001.ppm
